package freebridge.test;

import junit.framework.*;
import org.apache.log4j.Category;
import org.apache.log4j.PropertyConfigurator;

public class AllTests {
    static Category cat = Category.getInstance(AllTests.class.getName());

    public static Test suite(){
	cat.debug(" suite()");
	TestSuite suite = new TestSuite("All JUnit Tests");
	suite.addTest(CardTest.suite());
	suite.addTest(HandTest.suite());
	suite.addTest(OrientationTest.suite());
	suite.addTest(DealerTest.suite());
	suite.addTest(BidTest.suite());
	suite.addTest(ScoreTest.suite());
	suite.addTest(PlayerTest.suite());
	suite.addTest(VulnerabilityTest.suite());
	suite.addTest(MatchTest.suite());
	suite.addTest(TrickTest.suite());
	suite.addTest(BidStageTest.suite());
	suite.addTest(GameTest.suite());
	return suite;
    }

    public static void main(String args[]){
	PropertyConfigurator.configure(args[0]);
	cat.info("Starting tests");
	junit.textui.TestRunner.run(suite());
    }
}
