package freebridge.test;

import org.apache.log4j.Category;
import freebridge.core.*;
import freebridge.international.International;
import junit.framework.*;

public class BidTest extends TestCase {
    static Category cat = Category.getInstance(BidTest.class.getName());
    private International intl = new International();

    public static Test suite(){
	return new TestSuite(BidTest.class);
    }

    public void testBid(){
	try {
	    Bid b1 = new Bid();
	    b1.setValue(Bid.PASS);
	    Bid b2 = new Bid();
	    b2.setInsult(Bid.REDOUBLE);
	    Bid b3 = new Bid();
	    b3.setValue(5);
	    b3.setSuit(Bid.NOTRUMP);
	    Bid b4 = new Bid();
	    b4.setValue(2);
	    b4.setSuit(Card.SPADES);
	    Assert.assertEquals("Passe",b1.show(intl));
	    Assert.assertEquals("5SA",b3.show(intl));
	}
	catch(Exception exp){
	    cat.error("Unexpected exception: "+exp.toString());
	    fail("Unexpected exception: "+exp.toString());
	}
    }

    public void testBadBid(){
	try {
	    Bid b1 = new Bid();
	    b1.setValue(9);
	}
	catch(BadTypeException exp1){
	    cat.info("Expected exception thrown. This is okay");
	}
	catch(Exception exp){
	    cat.error("Unexpected exception: "+exp.toString());
	    fail("Unexpected exception: "+exp.toString());
	}
	try {
	    Bid b2 = new Bid();
	    b2.setSuit(72);
	}
	catch(BadTypeException exp1){
	    cat.info("Expected exception thrown. This is okay");
	}
	catch(Exception exp){
	    cat.error("Unexpected exception: "+exp.toString());
	    fail("Unexpected exception: "+exp.toString());
	}
    }

    public void testShow(){
	try {
	    Bid b1 = new Bid();
	    b1.setValue(7);
	    b1.setInsult(Bid.DOUBLE);
	    b1.setSuit(Bid.NOTRUMP);
	    Assert.assertEquals("7SAContre",b1.show(intl));
	    
	    Bid b2 = new Bid();
	    b2.setValue(3);
	    b2.setSuit(Card.SPADES);
	    Assert.assertEquals("3P",b2.show(intl));
	}
	catch(Exception exp){
	    cat.error("Unexpected exception: "+exp.toString());
	    fail("Unexpected exception: "+exp.toString());
	}
    }
}
