package freebridge.test;

import freebridge.core.Card;
import freebridge.international.International;
import junit.framework.*;
import org.apache.log4j.Category;

public class CardTest extends TestCase {
    static Category cat = Category.getInstance(CardTest.class.getName());

    public static Test suite(){
	return new TestSuite(CardTest.class);
    }

    public void testGet(){
	try {
	    Card c = new Card(2,Card.HEART);
	    Assert.assertEquals(2,c.getValue());
	    Assert.assertEquals(Card.HEART,c.getColour());
	    Assert.assertEquals(0,c.getHonourValue());

	    Card d = new Card(1,Card.SPADES);
	    Assert.assertEquals(4,d.getHonourValue());
	    Assert.assertEquals(Card.SPADES,d.getColour());
	}
	catch(Exception exp){
	    cat.error("Exception caught: "+exp.toString());
	    fail("Unexpected Exception caught !");
	}
    }

    public void testShowCard(){
	try {
	    International intl = new International("fr","FR");
	    Card ace = new Card(1,Card.CLUBS);
	    Card king = new Card(Card.KING,Card.DIAMOND);
	    cat.debug("testing showCardValue/showCardColour...");
	    
	    String s = ace.showCardValue(intl);
	    cat.debug("Show = "+s+" expected: A");
	    Assert.assertTrue(s.equals("A"));

	    s = king.showCardValue(intl);
	    cat.debug("Show = "+s+" expected: R");
	    Assert.assertTrue(s.equals("R"));
	    Assert.assertTrue(ace.showCardColour(intl).equals("T"));
	    Assert.assertTrue(king.showCardColour(intl).equals("K"));
	}
	catch(Exception exp){
	    cat.error("Exception caught: "+exp.toString());
	    fail("Unexpected Exception caught !");
	}
    }
    
}
