package freebridge.test;

import freebridge.core.*;
import freebridge.international.*;
import org.apache.log4j.Category;
import junit.framework.*;

/**
 * @author Axelle Apvrille
 * @version 0.1
 */
public class DealerTest extends TestCase {
    static Category cat = Category.getInstance(DealerTest.class.getName());
    private International intl = new International();

    public static Test suite(){
	return new TestSuite(DealerTest.class);
    }

    public void testDeal(){
	Dealer d = new Dealer();
	cat.debug("Initial layout of the deck...");
	d.dumpDeck();

	cat.debug("Creating the hands...");
	Hand n,e,s,w;
	n = new Hand();
	e = new Hand();
	s = new Hand();
	w = new Hand();

	cat.debug("North will be dealing...");
	try {
	    Orientation dealer = new Orientation(Orientation.NORTH);
	    d.deal(n,e,s,w,dealer); // exception will be thrown if error.
	    cat.debug("Finished dealing...");
	    d.dumpDeck();
	    
	    cat.debug("South will be dealing...");
	    dealer = new Orientation(Orientation.SOUTH);
	    n.resetHand();
	    e.resetHand();
	    s.resetHand();
	    w.resetHand();
	    d.deal(n,e,s,w,dealer); // exception will be thrown if error.
	    cat.debug("Finished dealing...");
	    d.dumpDeck();
	}
	catch(Exception exp){
	    cat.error("Unexpected exception: "+exp.toString());
	    fail("Unexpected exception: "+exp.toString());
	}
    }
}
