package freebridge.test;

import freebridge.core.*;
import freebridge.international.International;
import junit.framework.*;
import org.apache.log4j.Category;
import java.util.Vector;
import java.util.Iterator;

public class HandTest extends TestCase {
    static Category cat = Category.getInstance(HandTest.class.getName());
    private International intl = new International();

    public static Test suite(){
	return new TestSuite(HandTest.class);
    }

    public void testHand(){
	cat.debug("Testing constructor of hand");
	Hand h = new Hand();
    }

    public void testShowHand(){
	cat.debug("> testShowHand()");
	Hand h = new Hand();
	try {
	    Card c1 = new Card(2,Card.CLUBS);
	    Card c2 = new Card(10,Card.HEART);
	    Card c3 = new Card(Card.ACE,Card.CLUBS);
	    Card c4 = new Card(12,Card.HEART);
	    Card c5 = new Card(Card.KING,Card.CLUBS);

	    h.addCard(c1);
	    h.addCard(c2);
	    h.addCard(c3);
	    h.addCard(c4);
	    h.addCard(c5);

	    cat.info("Your hand is: "+h.showHand(intl));
	}
	catch(Exception exp){
	    cat.error("Unexpected exception: "+exp.toString());
	    fail("Unexpected exception: "+exp.toString());
	}
	cat.debug("< testShowHand()");
    }

    public void testAddSelectReset(){
	Hand h = new Hand();
	try {
	    Card c1 = new Card(2,Card.CLUBS);
	    Card c2 = new Card(10,Card.HEART);
	    Card c3 = new Card(Card.ACE,Card.CLUBS);
	    Card c4 = new Card(12,Card.HEART);
	    Card c5 = new Card(Card.KING,Card.CLUBS);

	    cat.debug("Testing adding a card in the hand");	    
	    h.addCard(c1);
	    h.addCard(c2);
	    h.addCard(c3);
	    h.addCard(c4);
	    h.addCard(c5);

	    cat.debug("Testing selecting cards of a given colour");
	    Vector v = h.selectColour(Card.CLUBS);
	    Iterator i = v.iterator();
	    while (i.hasNext()){
		cat.info(((Card)i.next()).toString());
	    }
	    Assert.assertEquals(3,v.size());

	    v = h.selectColour(Card.HEART);
	    Assert.assertEquals(2,v.size());

	    cat.debug("Play a card");
	    h.playCard(c3);
	    v = h.selectColour(Card.CLUBS);
	    Assert.assertEquals(2,v.size());

	    cat.debug("Reset the hand");
	    h.resetHand();
	    v = h.selectColour(Card.HEART);
	    Assert.assertTrue(v.isEmpty());
	}
	catch(Exception exp){
	    cat.error("Unexpected exception: "+exp.toString());
	    fail("Unexpected exception: "+exp.toString());
	}
	
    }
}
