package freebridge.test;

import org.apache.log4j.Category;
import junit.framework.*;
import freebridge.core.*;
import freebridge.console.*;

public class MatchTest extends TestCase {
    static Category cat = Category.getInstance(MatchTest.class.getName());

    public static Test suite(){
	return new TestSuite(MatchTest.class);
    }

    public void testMatch(){
	cat.debug("Simple match constructor test");
	Match m = new Match();
	ConsolePlayer n = new ConsolePlayer("Croc' Mister");
	ConsolePlayer e = new ConsolePlayer("Picus");
	ConsolePlayer s = new ConsolePlayer("Croc' Miss");
	ConsolePlayer w = new ConsolePlayer("Hareng Glouton");
	Assert.assertEquals(Vulnerability.NOBODY,m.getVulnerability().getVulnerability());
	Assert.assertEquals(Orientation.NORTH,m.getDealer().getOrientation());
	m.setNorth(n);
	m.setEast(e);
	m.setSouth(s);
	m.setWest(w);

	cat.info("Testing getSouth");
	Assert.assertEquals("Croc' Miss",m.getSouth().getName());
    }

    public void testNext(){
	cat.info("Testing multiple games in a match");
	Match m = new Match();
	ConsolePlayer n = new ConsolePlayer("Croc' Mister");
	ConsolePlayer e = new ConsolePlayer("Picus");
	ConsolePlayer s = new ConsolePlayer("Croc' Miss");
	ConsolePlayer w = new ConsolePlayer("Hareng Glouton");
	m.setNorth(n);
	m.setEast(e);
	m.setSouth(s);
	m.setWest(w);

	m.nextGame();
	Assert.assertEquals(Vulnerability.NORTH_SOUTH,m.getVulnerability().getVulnerability());
	Assert.assertEquals(Orientation.EAST,m.getDealer().getOrientation());
    }

    public void testGetDealer(){
	cat.debug("> MatchTest::testGetDealer()");
	Match m = new Match();
	Assert.assertEquals(Orientation.NORTH,m.getDealer().getOrientation());
	cat.debug("< MatchTest::testGetDealer()");
    }
}
