package freebridge.test;

import freebridge.core.*;
import freebridge.international.International;
import junit.framework.*;
import org.apache.log4j.Category;

public class OrientationTest extends TestCase {
    static Category cat = Category.getInstance(OrientationTest.class.getName());
    private International intl = new International();
    public static Test suite(){
	return new TestSuite(OrientationTest.class);
    }

    public void testGet(){
	try {
	    Orientation orientation = new Orientation(Orientation.EAST);
	    Assert.assertEquals(Orientation.EAST,orientation.getOrientation());
	}
	catch(Exception exp){
	    cat.error("unexpected exception: "+exp.toString());
	    fail("Unexpected exception: "+exp.toString());
	}
    }

    public void testNext(){
	try {
	    Assert.assertEquals(Orientation.NORTH,Orientation.next(Orientation.WEST));
	    Assert.assertEquals(Orientation.SOUTH,Orientation.next(Orientation.EAST));
	}
	catch(Exception exp){
	    cat.error("unexpected exception: "+exp.toString());
	    fail("Unexpected exception: "+exp.toString());
	}
    }

    public void testShow(){
	try {
	    Orientation orientation = new Orientation(Orientation.EAST);
	    Assert.assertEquals("Est",orientation.show(intl));
	}
	catch(Exception exp){
	    cat.error("unexpected exception: "+exp.toString());
	    fail("Unexpected exception: "+exp.toString());
	}
    }
}
