package freebridge.test;

import org.apache.log4j.Category;
import junit.framework.*;
import freebridge.core.*;
import freebridge.console.ConsolePlayer;

public class PlayerTest extends TestCase {
    static Category cat = Category.getInstance(PlayerTest.class.getName());

    public static Test suite(){
	return new TestSuite(PlayerTest.class);
    }
    
    public void testScore(){
	cat.debug("Testing addScore/resetScore/getGlobalScore");
	Player p = new ConsolePlayer("John Doe");
	Assert.assertEquals(0,p.getGlobalScore());
	p.addScore(100);
	Assert.assertEquals(100,p.getGlobalScore());
	p.resetGlobalScore();
	Assert.assertEquals(0,p.getGlobalScore());
    }

    public void testName(){
	cat.debug("Testing the get/set name for the player");
	Player p = new ConsolePlayer("Picus");
	Assert.assertEquals("Picus",p.getName());
    }

    public void testOrientation(){
	cat.debug("Testing the set/getOrientation on player");
	Player p = new ConsolePlayer("Croc' Mister ");
	Assert.assertEquals(Orientation.NORTH,p.getOrientation().getOrientation());

	try {
	    Orientation o = new Orientation(Orientation.SOUTH);
	    p.setOrientation(o); 
	    Assert.assertEquals(Orientation.SOUTH,p.getOrientation().getOrientation());
	}
	catch(Exception exp){
	    fail("Unexpected exception "+exp.toString());
	}
    }

    public void testHand(){
	cat.debug("Testing set/get hand of player");
	Player p = new ConsolePlayer("Croc' Mister ");
	Assert.assertEquals(null,p.getHand());

	try {
	    Hand h = new Hand();
	    Card c = new Card(3,Card.SPADES);
	    h.addCard(c);
	    p.setHand(h);
	    Assert.assertEquals(h,p.getHand());
	}
	catch(Exception exp){
	    fail("Unexpected exception "+exp.toString());
	}
	}
}
