package freebridge.test;

import freebridge.core.*;
import org.apache.log4j.Category;
import junit.framework.*;

public class ScoreTest extends TestCase {
    static Category cat = Category.getInstance(ScoreTest.class.getName());

    public static Test suite(){
	return new TestSuite(ScoreTest.class);
    }

    public void testSetGet() {
	cat.debug("Testing set/get for Scores...");
	try {
	    Score s = new Score();
	    Bid r = new Bid();
	    r.setValue(7);
	    r.setSuit(Card.HEART);
	    s.setBidRequest(r);
	    Assert.assertEquals(r,s.getBidRequest());
	}
	catch(Exception exp){
	    cat.error("Unexpected exception: "+exp);
	    fail("Unexpected exception: "+exp);
	}
    }

    public void testScore(){
	cat.debug("Creating score object");
	try {
	    Score s = new Score();
	    
	    cat.debug("Creating bids");
	    Bid r = new Bid();
	    Bid d = new Bid();
	    r.setValue(4);
	    r.setSuit(Card.SPADES);
	    d.setValue(4);
	    d.setSuit(Card.SPADES);
	    s.setBidRequest(r);
	    s.setBidDone(d);
	    cat.debug("Computing score for 4Spades done equal");
	    Assert.assertEquals(420,s.computeScore());

	    r.setValue(6);
	    r.setSuit(Card.DIAMOND);
	    d.setValue(4);
	    d.setSuit(Card.DIAMOND);
	    d.setInsult(Bid.DOUBLE);
	    s.setBidRequest(r);
	    s.setBidDone(d);
	    s.setVulnerable(true);
	    cat.debug("Computing score for 6Diamond failed by 2, doubled and vulnerable");
	    Assert.assertEquals(-500,s.computeScore());
	    
	}
	catch(Exception exp){
	    cat.error("Unexpected exception: "+exp);
	    fail("Unexpected exception: "+exp);
	}
	
	
    }
}
