package freebridge.core;

import org.apache.log4j.Category;

public class Vulnerability {
    static Category cat = Category.getInstance(Vulnerability.class.getName());

    public static final int NOBODY = 0;
    public static final int NORTH_SOUTH = 1;
    public static final int EAST_WEST = 2;
    public static final int EVERYBODY = 3;

    private int vuln;

    public Vulnerability() {
	vuln = NOBODY;
    }

    public int next() {
	cat.debug("> next(): current vulnerability is "+vuln);
	if (vuln == EVERYBODY) vuln = NOBODY;
	else vuln++;
	cat.debug("< next(): next vulnerability is "+vuln);
	return vuln;
    }

    /**
     * @param v an orientation value 
     * @return true is you're vulnerable
     */
    public boolean isVulnerable(Orientation v) {
	cat.debug("isVulnerable(): v="+v.toString());
	if (((v.getOrientation() == Orientation.NORTH ) || (v.getOrientation() == Orientation.SOUTH)) 
	    && ((vuln == NORTH_SOUTH) || (vuln == EVERYBODY)))
	    return true;
	if (((v.getOrientation() == Orientation.EAST ) || (v.getOrientation() == Orientation.WEST)) 
	    && ((vuln == EAST_WEST) || (vuln == EVERYBODY)))
	    return true;
	return false;
    }

    public int getVulnerability() { return vuln; }
    public void setVulnerability(int v) throws BadTypeException {
	cat.debug("> setVulnerability() : v= "+v);
	if ((vuln < NOBODY) || (vuln > EVERYBODY)) throw new BadTypeException("Impossibile vulnerability value: "+v);
	vuln = v;
	cat.debug("< setVulnerability()");
    }

    public String toString(){
	return Integer.toString(vuln);
    }
}
