package freebridge.test;

import org.apache.log4j.Category;
import junit.framework.*;
import freebridge.core.*;

public class VulnerabilityTest extends TestCase {
    static Category cat = Category.getInstance(VulnerabilityTest.class.getName());
    public static Test suite(){
	return new TestSuite(VulnerabilityTest.class);
    }

    public void testConstruct(){
	cat.debug("Testing constructor");
	Vulnerability vuln = new Vulnerability();
	Assert.assertEquals(Vulnerability.NOBODY,vuln.getVulnerability());
    }

    public void testGetSet(){
	cat.debug("Testing get/set");
	try {
	    Vulnerability vuln = new Vulnerability();
	    vuln.setVulnerability(Vulnerability.NORTH_SOUTH);
	    Assert.assertEquals(Vulnerability.NORTH_SOUTH,vuln.getVulnerability());
	}
	catch(Exception exp){
	    cat.error("Unexpected exception: "+exp);
	    fail("Unexpected exception: "+exp);
	}
    }

    public void testIsVulnerable(){
	cat.debug("Testing isVulnerable");
	Vulnerability vuln = new Vulnerability();
	try {
	    vuln.setVulnerability(Vulnerability.EAST_WEST);
	    Assert.assertTrue(vuln.isVulnerable(new Orientation(Orientation.EAST)));
	    Assert.assertTrue(vuln.isVulnerable(new Orientation(Orientation.WEST)));
	    Assert.assertTrue(!vuln.isVulnerable(new Orientation(Orientation.NORTH)));
	    
	    vuln.setVulnerability(Vulnerability.EVERYBODY);
	    Assert.assertTrue(vuln.isVulnerable(new Orientation(Orientation.SOUTH)));
	}
	catch(Exception exp){
	    cat.error("Unexpected exception: "+exp);
	    fail("Unexpected exception: "+exp);
	}
    }
}
